/* Plugin generated by AMXX-Studio */

#include <amxmodx>
#include <fakemeta>
#include <fakemeta_util>
#include <xs>
#include <zombieplague>
#include <hamsandwich>

#define PLUGIN "[ZP] Extra Item: Barnacle"
#define VERSION "0.1.0"
#define AUTHOR "PomanoB"

#define HEALTH_OFFSET 500
#define THINK_DELAY 0.1

new const g_item_name[] = "Barnacle"
const g_item_cost = 2

enum
{
	idle1,
	idle2,
	idle3,
	flinch_sm,
	attack1,
	chewcycle,
	death
}

new const barnacle_class[] = "barnacle"
new g_mdl_gib_head

new g_CvarSpeed, g_CvarDamage, g_CvarHP, g_CvarInfect

new g_itemid_branacle

new g_barnacleCount[33]

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
		
	register_event("HLTV", "eventFreezeTimeStart", "a", "1=0", "2=0")
	
	register_forward(FM_Think, "fwdThink")
	
	g_CvarSpeed = register_cvar("barnacle_speed", "20.0")
	g_CvarDamage = register_cvar("barnacle_damage", "30.0")
	g_CvarHP = register_cvar("barnacle_hp", "500.0")
	g_CvarInfect = register_cvar("barnacle_infect", "1")
	
	g_itemid_branacle = zp_register_extra_item(g_item_name, g_item_cost, ZP_TEAM_ZOMBIE)
	
	register_clcmd("say /barnacle", "create_barnacle")
}

public plugin_precache()
{
	precache_model("models/barnacle.mdl")
	precache_model("models/barnaclet.mdl")
	
	precache_sound("barnacle/bcl_alert2.wav")
	precache_sound("barnacle/bcl_chew1.wav")
	precache_sound("barnacle/bcl_chew2.wav")
	precache_sound("barnacle/bcl_chew3.wav")
	precache_sound("barnacle/bcl_die1.wav" )
	precache_sound("barnacle/bcl_die3.wav" )
	
	g_mdl_gib_head = precache_model("models/GIB_Skull.mdl")
}

public fwdThink(ent)
{
	if (!pev_valid(ent))
		return
	static class[32]
	pev(ent, pev_classname, class, 31)
	if (equal(barnacle_class, class))
	{
		
		static Float:takedamage, Float:origin[3], Float:endPoint[3], Float:gametime, tr, hit
		pev(ent, pev_takedamage, takedamage)
		if (pev(ent, pev_health) - HEALTH_OFFSET <= 0 && takedamage == DAMAGE_YES)
		{
			set_pev(ent, pev_animtime, 6.6)
			set_pev(ent,pev_framerate, 1.0)
			set_pev(ent,pev_sequence, death)
			
			set_pev(ent, pev_takedamage, DAMAGE_NO)
			set_pev(ent, pev_controller_0, 255)
			set_pev(ent, pev_nextthink, get_gametime() + 99999.0)
			
			set_pev(ent, pev_solid, SOLID_NOT)
			
			switch(random_num(0, 1))
			{
				case 0:
					engfunc(EngFunc_EmitSound, ent, CHAN_WEAPON, "barnacle/bcl_die1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
				case 1:
					engfunc(EngFunc_EmitSound, ent, CHAN_WEAPON, "barnacle/bcl_die3.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			}
			
			pev(ent, pev_origin, origin)
			createGibs(origin)
			return			
		}
		else
		if (!pev(ent,pev_enemy) && takedamage == DAMAGE_YES)
		{
			
			pev(ent, pev_origin, origin)
			xs_vec_copy(origin, endPoint)
			endPoint[2]-=2048.0
			engfunc(EngFunc_TraceLine, origin, endPoint, DONT_IGNORE_MONSTERS, ent, tr)
			hit = get_tr2(tr, TR_pHit)
			if (is_user_alive(hit)  && !zp_get_user_zombie(hit))
			{
				set_pev(ent, pev_enemy, hit)
				set_pev(ent, pev_sequence, chewcycle)
				set_pev(ent, pev_gaitsequence, chewcycle)
				engfunc(EngFunc_EmitSound, ent, CHAN_WEAPON, "barnacle/bcl_alert2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			}
			else
			if (!pev(ent, pev_controller_0))
			{
				get_tr2(tr, TR_vecEndPos, endPoint)
				set_pev(ent, pev_controller_0, 281 - floatround(255.0 / 1024.0 * (origin[2] - endPoint[2])))
			}
			free_tr2(tr)
							
		}
		else
		if (takedamage == DAMAGE_YES)
		{
			static id, Float:distance, Float:flNextAttackTime
			id = pev(ent,pev_enemy)
			if (is_user_alive(id))
			{
				pev(ent, pev_origin, origin)
				pev(id, pev_origin, endPoint)
				distance = origin[2] - endPoint[2]
				if (distance > 100.0)
				{
					endPoint[0] = origin[0]
					endPoint[1] = origin[1]
					endPoint[2] += get_pcvar_float(g_CvarSpeed)
					set_pev(id, pev_origin, endPoint)
					set_pev(ent, pev_controller_0, 261 - floatround(255.0 / 1024.0 * distance))
				}
				else
				{
					if (get_pcvar_num(g_CvarInfect) && !(
						zp_get_user_last_human(id) ||
						zp_get_user_survivor(id) ||
						zp_is_survivor_round() || 
						zp_is_swarm_round()
					))
					{
						zp_infect_user(id, pev(ent, pev_iuser1), 0, 1)
						release(ent)
						
					}
					else
					{
						pev(ent, pev_fuser1, flNextAttackTime)
						gametime = get_gametime()
						if (flNextAttackTime <= gametime)
						{
							ExecuteHamB(Ham_TakeDamage, id, ent, pev(ent, pev_iuser1), get_pcvar_float(g_CvarDamage), DMG_GENERIC)
							set_pev(ent, pev_fuser1, gametime + 1.0)
							
							switch(random_num(0, 2))
							{
								case 0:
									engfunc(EngFunc_EmitSound, ent, CHAN_WEAPON, "barnacle/bcl_chew1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
								case 1:
									engfunc(EngFunc_EmitSound, ent, CHAN_WEAPON, "barnacle/bcl_chew2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
								case 2:
									engfunc(EngFunc_EmitSound, ent, CHAN_WEAPON, "barnacle/bcl_chew3.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)	
							}
						}
						if (pev(ent,pev_sequence) != attack1)
						{
							set_pev(ent,pev_sequence, attack1)
							set_pev(ent,pev_gaitsequence, attack1)
							set_pev(ent, pev_controller_0, 255)
						}
					}
				}
				set_pev(id, pev_velocity, Float:{0.0, 0.0, 0.0})
			}
			else
				release(ent)
			
		}
		set_pev(ent, pev_nextthink, get_gametime() + THINK_DELAY)
	}
}

public create_barnacle(id)
{
	if (!zp_get_user_zombie(id))
	{
		client_print(id, print_center, "Only zombie can use barnacle!")
		return
	}
	if (g_barnacleCount[id] > 0)
	{
		new origin[3], Float:fOrigin[3]
		get_user_origin(id, origin, 3)
		IVecFVec(origin, fOrigin)
		
		fOrigin[2] -= 2.0
		new const Float:direction[4][3] = {{5.0, 0.0, 0.0}, {-5.0, 0.0, 0.0}, {0.0, 5.0, 0.0}, {0.0, -5.0, 0.0}}
		new Float:temp[3]
		xs_vec_copy(fOrigin, temp)
		new i
		for (i = 0; i < 4; i++)
		{
			xs_vec_add(fOrigin, direction[i], temp)
			if (engfunc(EngFunc_PointContents, temp) != -1)
				break
		}
		
		if (i != 4)
			client_print(id, print_center, "Invalid location!")
		else
		{
			fOrigin[2] += 2.0
			new ent = engfunc(EngFunc_CreateNamedEntity,engfunc(EngFunc_AllocString,"info_target"))
		
			set_pev(ent,pev_classname, barnacle_class)
			engfunc(EngFunc_SetModel, ent, "models/barnacle.mdl")
		 
			set_pev(ent, pev_iuser1, id)
		 
			set_pev(ent, pev_mins, Float:{-16.0,-16.0, -36.0})
			set_pev(ent, pev_maxs, Float:{16.0,16.0,0.0})
			set_pev(ent, pev_size, Float:{-16.0,-16.0, -36.0,16.0,16.0,0.0})
			engfunc(EngFunc_SetSize, ent, Float:{-16.0,-16.0,-36.0}, Float:{16.0,16.0,0.0})
			
			set_pev(ent, pev_solid, SOLID_BBOX)
			set_pev(ent, pev_movetype, MOVETYPE_FLY)
		
			set_pev(ent, pev_health, get_pcvar_float(g_CvarHP) + HEALTH_OFFSET)
			set_pev(ent, pev_takedamage, 1.0)
		
			set_pev(ent, pev_dmg, 1.0)
		
			set_pev(ent, pev_maxspeed, 20.0)
		
			set_pev(ent,pev_flags, FL_MONSTER|FL_MONSTERCLIP)
		
			set_pev(ent, pev_origin, fOrigin)
			
			set_pev(ent, pev_animtime, 10.0)
			set_pev(ent, pev_framerate, 0.5)
			set_pev(ent, pev_sequence, idle3)
			set_pev(ent, pev_gaitsequence, idle3)
			
			set_pev(ent, pev_nextthink,get_gametime() + THINK_DELAY)
			
			g_barnacleCount[id]--
			
			client_print(id, print_center, "Barnacle count: %d", g_barnacleCount[id])
		}
	}
	else
		client_print(id, print_center, "You have not barnacle!")
}

public eventFreezeTimeStart()
{
	static string_class[] = "classname"
	new ent = FM_NULLENT
	while ((ent = engfunc(EngFunc_FindEntityByString, ent, string_class, barnacle_class))) 
		set_pev(ent, pev_flags, FL_KILLME)
	new i
	for (i = 0; i < 33; i++)
		g_barnacleCount[i] = 0
}

public createGibs(Float:origin[3])
{
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_MODEL)
	engfunc(EngFunc_WriteCoord, origin[0])
	engfunc(EngFunc_WriteCoord, origin[1])
	engfunc(EngFunc_WriteCoord, origin[2]-40.0)
	write_coord(random_num(-20, 20))
	write_coord(random_num(-20, 20))
	write_coord(random_num(-20, 0))
	write_angle(random_num(0,360))
	write_short(g_mdl_gib_head)
	write_byte(0)
	write_byte(400)
	message_end()
}

public release(ent)
{
	new Float:origin[3], Float:endPoint[3], tr
	set_pev(ent, pev_enemy, 0)
				
	pev(ent, pev_origin, origin)
	xs_vec_copy(origin, endPoint)
	endPoint[2]-=2048.0
	engfunc(EngFunc_TraceLine, origin, endPoint, IGNORE_MONSTERS, ent, tr)
	
	get_tr2(tr, TR_vecEndPos, endPoint)
	free_tr2(tr)
	set_pev(ent, pev_controller_0, 281 - floatround(255.0 / 1024.0 * (origin[2] - endPoint[2])))
	
	set_pev(ent, pev_animtime, 10.0)
	set_pev(ent, pev_framerate, 0.5)
	set_pev(ent, pev_sequence, idle3)
	set_pev(ent, pev_gaitsequence, idle3)
	
	free_tr2(tr)
}

public zp_extra_item_selected(id, itemid)
{
	if (itemid == g_itemid_branacle)
	{
		client_print(id, print_center, "Use command ^"say /barnacle^" to place barnacle")
		g_barnacleCount[id] += 10
	}
}
